#ifndef MSP_CORE_EXCEPT_H_
#define MSP_CORE_EXCEPT_H_

#include <stdexcept>
#include "mspcore_api.h"

namespace Msp {

class MSPCORE_API invalid_state: public std::logic_error
{
public:
	invalid_state(const std::string &w): logic_error(w) { }
};


class MSPCORE_API already_called: public invalid_state
{
public:
	already_called(const std::string &w): invalid_state(w) { }
};


class MSPCORE_API unsupported: public std::logic_error
{
public:
	unsupported(const std::string &w): logic_error(w) { }
};


class MSPCORE_API internal_error: public std::logic_error
{
public:
	internal_error(const std::string &w): logic_error(w) { }
};

} // namespace Msp;

#endif
