#ifndef MSP_DEBUG_BACKTRACE_H_
#define MSP_DEBUG_BACKTRACE_H_

#include <ostream>
#include <string>
#include <vector>
#include <msp/core/mspcore_api.h>

namespace Msp {
namespace Debug {

class MSPCORE_API Backtrace
{
public:
	struct StackFrame
	{
		void *address = nullptr;
		std::string file;
		std::string symbol;
	};

private:
	std::vector<StackFrame> frames;

public:
	const std::vector<StackFrame> &get_frames() const { return frames; }

	static Backtrace create();
};

MSPCORE_API std::ostream &operator<<(std::ostream &, const Backtrace &);
MSPCORE_API std::ostream &operator<<(std::ostream &, const Backtrace::StackFrame &);

} // namespace Debug
} // namespace Msp

#endif
