#include <grp.h>
#include <pwd.h>
#include <msp/strings/format.h>
#include "stat.h"
#include "stat_private.h"

namespace Msp {
namespace FS {

void Stat::Private::fill_owner_info(Stat::OwnerInfo &result)
{
	if(owner_id!=INVALID_UID)
	{
		struct passwd *owner;
		if((owner = getpwuid(owner_id)))
			result.owner = owner->pw_name;
		else
			result.owner = format("%d", owner_id);
	}
	else
		result.owner = "None";

	if(group_id!=INVALID_GID)
	{
		struct group *group;
		if((group = getgrgid(group_id)))
			result.group = group->gr_name;
		else
			result.group = format("%d", group_id);
	}
	else
		result.group = "None";
}

} // namespace FS
} // namespace Msp
