#ifndef MSP_IO_HANDLE_H_
#define MSP_IO_HANDLE_H_

#include <cstddef>
#include <msp/core/mspcore_api.h>

namespace Msp {
namespace IO {

class MSPCORE_API Handle
{
public:
	struct Private;

private:
	Private *priv = nullptr;

public:
	Handle();
	Handle(const Handle &);
	Handle &operator=(const Handle &);
	~Handle();

	Private &operator*() { return *priv; }
	const Private &operator*() const { return *priv; }

	explicit operator bool() const;
};


void sys_set_blocking(Handle &, bool);
void sys_set_inherit(Handle &, bool);
std::size_t sys_read(Handle &, char *, std::size_t);
std::size_t sys_write(Handle &, const char *, std::size_t);
void sys_close(Handle &);

} // namespace IO
} // namespace Msp

#endif
