#ifndef MSP_IO_PIPE_H_
#define MSP_IO_PIPE_H_

#include <msp/core/mspcore_api.h>
#include "eventobject.h"
#include "eventreader.h"
#include "handle.h"

namespace Msp {
namespace IO {

class MSPCORE_API Pipe: public EventObject
{
private:
	Handle read_handle;
	Handle write_handle;
	EventReader reader;

public:
	Pipe();
private:
	void platform_init();
public:
	~Pipe();

	void set_mode(Mode);
	void set_block(bool) override;
	void set_inherit(bool) override;

protected:
	std::size_t do_write(const char *, std::size_t) override;
	std::size_t do_read(char *, std::size_t) override;

public:
	const Handle &get_handle(Mode) override;
	const Handle &get_event_handle() override { return reader.get_event(); }
};

} // namespace IO
} // namespace Msp

#endif
