#ifndef MSP_STRINGCODEC_ISO88591_H_
#define MSP_STRINGCODEC_ISO88591_H_

#include <msp/core/mspcore_api.h>
#include "codec.h"

namespace Msp {
namespace StringCodec {

class MSPCORE_API Iso88591: public StandardCodec<Iso88591>
{
public:
	class MSPCORE_API Encoder: public Codec::Encoder
	{
	public:
		Encoder(ErrorMode em = DEFAULT): Codec::Encoder(em) { }

		void encode_char(unichar, std::string &) override;
	private:
		void transliterate(unichar, std::string &) override;
	};

	class MSPCORE_API Decoder: public Codec::Decoder
	{
	public:
		Decoder(ErrorMode em = DEFAULT): Codec::Decoder(em) { }

		unichar decode_char(const std::string &, std::string::const_iterator &) override;
	};

	Iso88591(ErrorMode em = DEFAULT): StandardCodec<Iso88591>(em) { }

	const char *get_name() const override { return "ISO-8859-1"; }
};

} // namespace StringCodec
} // namespace Msp

#endif
