#ifndef MSP_STRINGCODEC_UTF8_H_
#define MSP_STRINGCODEC_UTF8_H_

#include <msp/core/mspcore_api.h>
#include "codec.h"

namespace Msp {
namespace StringCodec {

class MSPCORE_API Utf8: public StandardCodec<Utf8>
{
public:
	class MSPCORE_API Encoder: public Codec::Encoder
	{
	public:
		Encoder(ErrorMode em = DEFAULT): Codec::Encoder(em) { }

		void encode_char(unichar, std::string &) override;
	private:
		void transliterate(unichar, std::string &) override;
	};

	class MSPCORE_API Decoder: public Codec::Decoder
	{
	public:
		Decoder(ErrorMode em = DEFAULT): Codec::Decoder(em) { }

		unichar decode_char(const std::string &, std::string::const_iterator &) override;
	};

	Utf8(ErrorMode em = DEFAULT): StandardCodec<Utf8>(em) { }

	const char *get_name() const override { return "UTF-8"; }
};

} // namespace StringCodec
} // namespace Msp

#endif
