#ifndef MSP_TIME_UTILS_H_
#define MSP_TIME_UTILS_H_

#include <string>
#include <msp/core/mspcore_api.h>

namespace Msp {
namespace Time {

class TimeDelta;
class TimeStamp;

/** Returns the current timestamp. */
MSPCORE_API TimeStamp now();

MSPCORE_API std::string format_now(const std::string &);

/** Returns the CPU time used by the program so far. */
MSPCORE_API TimeDelta get_cpu_time();

/** Sleeps for the given duration. */
MSPCORE_API void sleep(const TimeDelta &);

} // namespace Time
} // namespace Msp

#endif
